<cffunction name="extractAttribute" output="false" returntype="any">
	<cfargument name="attrs" type="any" />
	<cfargument name="name" type="string" />
	<cfset var result = attrs.get(name) />
	<cfset attrs.remove(name) />
	<cfif isDefined("result")>
		<cfreturn result />
	<cfelse>
		<cfreturn "" />
	</cfif>
</cffunction>



<cffunction name="getAttributes" output="false" returntype="any">
	<cfargument name="tag" type="string" />
	<cfreturn getPageContext().getRequest().getAttribute("#tag#Attributes") />
</cffunction>



<cffunction name="getContext" output="false" returntype="any">
	<cfargument name="tag" type="string" />
	<cfreturn getPageContext().getRequest().getAttribute("#tag#Context") />
</cffunction>



<cffunction name="injectQuotedStrings" output="false" returntype="string">
	<cfargument name="sql" type="string" required="true" />
	<cfargument name="container" type="struct" required="true" />
	<cfargument name="quote" type="string" required="true" />
	<cfset var i = "" />
	<cfloop collection="#container#" item="i">
		<cfset sql = replace(sql, i, quote & container[i] & quote) />
	</cfloop>
	<cfreturn sql />
</cffunction>



<cffunction name="removeQuotedStrings" output="false" returntype="string">
	<cfargument name="sql" type="string" required="true" />
	<cfargument name="container" type="struct" required="true" />
	<cfargument name="quote" type="string" required="true" />
	<cfloop condition="true">
		<cfset q = REFind("#quote#([^#quote#]*)#quote#", sql, 1, true) />
		<cfif q.pos[1] LTE 0>
			<cfbreak />
		</cfif>
		<cftrace text="processing: #sql#" />
		<cfset parts = structNew() />
		<cfif q.pos[1] GT 1>
			<cfset parts.head = left(sql, q.pos[1] - 1) />
		<cfelse>
			<cfset parts.head = "" />
		</cfif>
		<cfset parts.string = mid(sql, q.pos[2], q.len[2]) />
		<cfset parts.tail = removeChars(sql, 1, q.pos[1] + q.len[1] - 1) />
		
		<cfset key = "__#quote#_string_" & structCount(container) & "__" />
		<cfset container[key] = parts.string />
		<cfset sql = parts.head & key & parts.tail />
	</cfloop>
	<cfreturn sql />
</cffunction>



<cffunction name="setResult" output="false" returntype="void">
	<cfargument name="tag" type="string" />
	<cfargument name="result" type="any" />
	<cfif structKeyExists(arguments, "result")>
		<cfset getPageContext().getRequest().setAttribute("#tag#Result", result) />
	<cfelse>
		<cfset getPageContext().getRequest().setAttribute("#tag#Result", javaCast("null", 0)) />
	</cfif>
</cffunction>
