ContactDao = Class.create();
ContactDao.prototype = Object.extend(new Object(), {
	
	initialize: function(config) {
		this.config = config;
		this.insertQuery = new Query("insert into contact (name, email) values (:name, :email)");
		this.deleteQuery = new Query("delete from contact where id = :id");
		this.getByIdQuery = new Query("select * from contact where id = :id");
		this.getListQuery = new Query("select * from contact order by name, id");
		this.getListByIdsQuery = new Query("select * from contact where id in (:ids) order by name, id");
		this.updateQuery = new Query("update contact set name = :name, email = :email where id = :id");
	},
	
	createContact: function(name, email) {
		this.insertQuery.execute({
			name: new QueryParam(name),
			email: new QueryParam(email)
		});
	},
	
	deleteContact: function(id) {
		this.deleteQuery.execute({
			id: new QueryParam(id, "integer")
		});
	},
	
	getContactById: function(id) {
		return this.getByIdQuery.execute({
			id: new QueryParam(id, "integer")
		});
	},
	
	getContactList: function() {
		return this.getListQuery.execute();
	},
	
	getContactListByIds: function(ids) {
		return this.getListByIdsQuery.execute({
			ids: new QueryParam(ids, "integer", true)
		});
	},
	
	updateContact: function(id, name, email) {
		this.updateQuery.execute({
				id: new QueryParam(id, "integer"),
				name: new QueryParam(name),
				email: new QueryParam(email)
		});
	}
	
});